accounts/urls.py
from django.urls import path, include
from . import views  # Import views from the same directory

app_name = "accounts"

urlpatterns = [
    path("login/", views.login_view, name="login"),
    path("logout/", views.logout_view, name="logout"),
]

expenses/urls.py
from django.contrib import admin
from django.urls import include, path
from django.shortcuts import redirect


def redirect_to_receipts(request):
    return redirect("receipts:home")


# Define the URL patterns
urlpatterns = [
    path("admin/", admin.site.urls),
    path("receipts/", include("receipts.urls")),
    path("", redirect_to_receipts),
    path("accounts/", include("accounts.urls")),
]

receipts/urls.py
from django.urls import path
from .views import receipt_list
from . import views

app_name = "receipts"

urlpatterns = [
    path("accounts/create/", views.create_account, name="create_account"),
    path("categories/create/", views.create_category, name="create_category"),
    path("categories/", views.category_list, name="category_list"),
    path("accounts/", views.account_list, name="account_list"),
    path("", views.receipt_list, name="home"),
    path("create/", views.create_receipt, name="create_receipt"),
]

receipts/models.py
from django.db import models
from django.contrib.auth.models import User
from decimal import Decimal

# Create your models here.


class ExpenseCategory(models.Model):
    name = models.CharField(max_length=50)
    owner = models.ForeignKey(
        User, related_name="categories", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Account(models.Model):
    name = models.CharField(max_length=100)
    number = models.CharField(max_length=20)
    owner = models.ForeignKey(
        User, related_name="accounts", on_delete=models.CASCADE
    )

    def __str__(self):
        return self.name


class Receipt(models.Model):
    vendor = models.CharField(max_length=200)
    total = models.DecimalField(max_digits=10, decimal_places=3)
    tax = models.DecimalField(max_digits=10, decimal_places=3)
    date = models.DateTimeField()
    purchaser = models.ForeignKey(
        User, related_name="receipts", on_delete=models.CASCADE
    )
    category = models.ForeignKey(
        ExpenseCategory, related_name="receipts", on_delete=models.CASCADE
    )
    account = models.ForeignKey(
        Account, related_name="receipts", on_delete=models.CASCADE, null=True
    )

    def __str__(self):
        return f"{self.vendor} - {self.date}"

receipts/forms.py
from django import forms
from .models import Receipt, ExpenseCategory, Account


class ReceiptForm(forms.ModelForm):
    class Meta:
        model = Receipt
        fields = ["vendor", "total", "tax", "date", "category", "account"]

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        self.fields["date"].widget.attrs.update(
            {"class": "datepicker"}
        )  # Assuming you use a datepicker

    def clean(self):
        cleaned_data = super().clean()
        # Additional validation if needed
        return cleaned_data


class ExpenseCategoryForm(forms.ModelForm):
    class Meta:
        model = ExpenseCategory
        fields = ["name"]


class AccountForm(forms.ModelForm):
    class Meta:
        model = Account
        fields = ["name", "number"]

receipts/views.py
from django.shortcuts import render, get_object_or_404, redirect
from django.contrib.auth.decorators import login_required
from receipts.models import ExpenseCategory, Account, Receipt
from receipts.forms import ReceiptForm, ExpenseCategoryForm, AccountForm

# Create your views here.


@login_required
def receipt_list(request):
    receipts = Receipt.objects.filter(purchaser=request.user)
    return render(
        request, "receipts/receipt_list.html", {"receipts": receipts}
    )


@login_required
def create_receipt(request):
    if request.method == "POST":
        form = ReceiptForm(request.POST)
        if form.is_valid():
            receipt = form.save(commit=False)
            receipt.purchaser = (
                request.user
            )  # Set the purchaser to the current logged-in user
            receipt.save()
            return redirect(
                "receipts:home"
            )  # Redirect to the home page (change 'home' to your actual home URL name)
    else:
        form = ReceiptForm()

    return render(request, "receipts/create_receipt.html", {"form": form})


@login_required
def category_list(request):
    categories = ExpenseCategory.objects.filter(owner=request.user)
    category_data = []

    for category in categories:
        receipt_count = Receipt.objects.filter(category=category).count()
        category_data.append(
            {"name": category.name, "receipt_count": receipt_count}
        )

    return render(
        request, "receipts/category_list.html", {"categories": category_data}
    )


@login_required
def account_list(request):
    accounts = Account.objects.filter(owner=request.user)
    account_data = []

    for account in accounts:
        receipt_count = Receipt.objects.filter(account=account).count()
        account_data.append(
            {
                "name": account.name,
                "number": account.number,
                "receipt_count": receipt_count,
            }
        )

    return render(
        request, "receipts/account_list.html", {"accounts": account_data}
    )


@login_required
def create_category(request):
    if request.method == "POST":
        form = ExpenseCategoryForm(request.POST)
        if form.is_valid():
            category = form.save(commit=False)
            category.owner = request.user
            category.save()
            return redirect("receipts:category_list")
    else:
        form = ExpenseCategoryForm()

    return render(request, "receipts/create_category.html", {"form": form})

@login_required
def create_account(request):
    if request.method == 'POST':
        form = AccountForm(request.POST)
        if form.is_valid():
            account = form.save(commit=False)
            account.owner = request.user
            account.save()
            return redirect('receipts:account_list')
    else:
        form = AccountForm()

    return render(request, 'receipts/create_account.html', {'form': form})

receipts/templates/receipts/account_list.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h1>Accounts</h1>
    <table>
      <thead>
        <tr>
          <th>Name</th>
          <th>Number</th>
          <th>Number of Receipts</th>
        </tr>
      </thead>
      <tbody>
        {% for account in accounts %}
        <tr>
          <td>{{ account.name }}</td>
          <td>{{ account.number }}</td>
          <td>{{ account.receipt_count }}</td>
        </tr>
        {% empty %}
        <tr>
          <td colspan="3">No accounts found.</td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</main>
{% endblock %}

receipts/templates/receipts/base.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <title>Your Title</title>
  </head>
  <body>
    <header>
      <nav>
        <ul>
          {% if user.is_authenticated %}
          <li><a href="{% url 'receipts:home' %}">Home</a></li>
          <li>
            <a href="{% url 'receipts:create_receipt' %}">Create Receipt</a>
          </li>
          <li></li>
          <li><a href="{% url 'receipts:home' %}">Home</a></li>
          <li><a href="{% url 'receipts:receipt_list' %}">Receipt List</a></li>
          <li>
            <a href="{% url 'receipts:category_list' %}">Category List</a>
          </li>
          <li><a href="{% url 'receipts:account_list' %}">Account List</a></li>
          <li>
            <a href="{% url 'receipts:create_receipt' %}">Create Receipt</a>
          </li>
          <li>
            <a href="{% url 'receipts:create_category' %}">Create Category</a>
          </li>
          <li>
            <a href="{% url 'receipts:create_account' %}">Create Account</a>
          </li>
          <li><a href="{% url 'accounts:logout' %}">Logout</a></li>
          {% else %}
          <li><a href="{% url 'accounts:signup' %}">Sign Up</a></li>
          <li><a href="{% url 'accounts:login' %}">Login</a></li>
        </ul>
      </nav>
    </header>

    {% block content %} {% endblock %}
  </body>
</html>

receipts/templates/receipts/category_list.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h1>Expense Categories</h1>
    <table>
      <thead>
        <tr>
          <th>Name</th>
          <th>Number of Receipts</th>
        </tr>
      </thead>
      <tbody>
        {% for category in categories %}
        <tr>
          <td>{{ category.name }}</td>
          <td>{{ category.receipt_count }}</td>
        </tr>
        {% empty %}
        <tr>
          <td colspan="2">No expense categories found.</td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
  </div>
</main>
{% endblock %}

receipts/templates/receipts/create_category.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h1>Create Category</h1>
    <form method="post">
      {% csrf_token %} {{ form.as_p }}
      <button type="submit">Create</button>
    </form>
  </div>
</main>
{% endblock %}

receipts/templates/receipts/create_receipt.html
{% extends 'base.html' %} {% block content %}
<main>
  <div>
    <h1>Create Receipt</h1>
    <form method="post">
      {% csrf_token %} {{ form.as_p }}
      <button type="submit">Create</button>
    </form>
  </div>
</main>
{% endblock %}

receipts/templates/receipts/receipt_list.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Receipts</title>
  </head>
  <body>
    <main>
      <div>
        <h1>My Receipts</h1>
        <table>
          <thead>
            <tr>
              <th>Vendor</th>
              <th>Total</th>
              <th>Tax</th>
              <th>Date</th>
              <th>Category</th>
              <th>Account</th>
            </tr>
          </thead>
          <tbody>
            {% for receipt in receipts %}
            <tr>
              <td>{{ receipt.vendor }}</td>
              <td>{{ receipt.total }}</td>
              <td>{{ receipt.tax }}</td>
              <td>{{ receipt.date }}</td>
              <td>{{ receipt.category.name }}</td>
              <td>{{ receipt.account.name }}</td>
            </tr>
            {% endfor %}
          </tbody>
        </table>
      </div>
    </main>
  </body>
</html>